:+1::tada: Hello, and thanks for contributing to
[GNSS-SDR](https://gnss-sdr.org)! :tada::+1:

<!-- prettier-ignore-start -->
[comment]: # (
SPDX-License-Identifier: GPL-3.0-or-later
)

[comment]: # (
SPDX-FileCopyrightText: 2011-2020 Carles Fernandez-Prades <carles.fernandez@cttc.es>
)
<!-- prettier-ignore-end -->

Before submitting your pull request, please make sure the following is done:

1.  You undertake the
    [Contributor Covenant Code of Conduct](https://github.com/gnss-sdr/gnss-sdr/blob/master/CODE_OF_CONDUCT.md).
2.  If you are a first-time contributor, after your pull request you will be
    asked to sign an Individual Contributor License Agreement
    ([CLA](https://en.wikipedia.org/wiki/Contributor_License_Agreement)) before
    your code gets accepted into `master`. This license is for your protection
    as a Contributor as well as for the protection of
    [CTTC](http://www.cttc.es/); it does not change your rights to use your own
    contributions for any other purpose. Except for the license granted therein
    to CTTC and recipients of software distributed by CTTC, you reserve all
    right, title, and interest in and to your contributions. The information you
    provide in that CLA will be maintained in accordance with
    [CTTC's privacy policy](http://www.cttc.es/privacy/).
3.  You have read the
    [Contributing Guidelines](https://github.com/gnss-sdr/gnss-sdr/blob/master/CONTRIBUTING.md).
4.  You have read the [coding style guide](https://gnss-sdr.org/coding-style/).
    Specifically, you have read
    [about clang-format](https://gnss-sdr.org/coding-style/#use-tools-for-automated-code-formatting)
    and [about clang-tidy](https://gnss-sdr.org/coding-style/#use-code-linters),
    and you have applied those tools to your changes.
5.  You have forked the
    [gnss-sdr upstream repository](https://github.com/gnss-sdr/gnss-sdr) and
    have created your branch from `next` (or any other currently living branch
    in the upstream repository).
6.  Please include a description of your changes here.

**Please feel free to delete this line and the above text once you have read it
and in case you want to go on with your pull request, and explain your intend
below.**
